#!/usr/local/bin/perl

# ★注意：このソースは UTF-8 にて保存


# ----------------------------------------------------------------------
# 外字入力アプレットの結果表示CGI
# ----------------------------------------------------------------------

# フォーム入力されたデータを格納
if ($ENV{'REQUEST_METHOD'} eq "POST") { read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'}); } else { $buffer = $ENV{'QUERY_STRING'}; }

# ローカルタイムのスタンプ用
($sec,$min,$hour,$day,$mon,$year,$wday,$yday)=localtime(time);
$year+=1900;
$mon++;

# 入力されたデータを文字列に代入・コード変換する
@pairs = split(/&/,$buffer);
foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$FORM{$name} = $value;
}

# CGIパラメタを取得 （del=削除、upd=更新、△=$mode値に従う）
$operation = $ENV{'QUERY_STRING'};

# ----------------------------------------------------------------------
# 設定値

# 自分自身のCGI名
$cgiName = "address_a.cgi";

# へプルのURL
$helpUrl = "help.html";

# アドレスファイル名
$addr_file = "address.dat";
$wk_file = "work.dat";

# アドレスの最大
$addrMax= 20;

# アプレットと通信するCGI「nph-cgij2.cgi」のフルパス
$aplCgiFullPath = "/cgi-bin/eudc/nph-cgij2.cgi";

# ReturnのURL
$homePath = "/";

# Formの入力データ取り出し
$NoText		= $FORM{'NoText'};
$EudcText	= $FORM{'EudcText'};
$AddrText	= $FORM{'AddrText'};
$TelText	= $FORM{'TelText'};
$mode		= $FORM{'mode'};

# 検索条件データ
$NoText_f	= "";
$EudcText_f	= "";
$AddrText_f	= "";
$TelText_f	= "";

# 処理のチェックマーク用変数
$check_ment	= "";
$check_find	= "";

# ----------------------------------------------------------------------
# オペレーションをチェック
$msg = "新規登録は、No未入力で各項目入力後、登録を選択し「処理」ボタンを押下して下さい。";
$op  = "";
if ($operation ne "")	{
	@item = split(/:/, $operation);
	if ($item[0] eq "del")	{
		# 削除
		$check_ment = "checked";
		if (&doUpdate("delete",$item[1]))	{
			$msg = "No." . $item[1] . " のデータを削除しました。（削除データは下記にコピーしているので再登録できます）";
			$op  = "del";
		}
		else	{
			$msg = "No." . $item[1] . " のデータは削除された可能性があります。処理出来ませんでした。";
			$op  = "err";
		}
	}
	else	{
		if ($item[0] eq "upd")	{
			# 修正
			$check_ment = "checked";
			if (&doUpdate("read",$item[1]))	{
				$msg = "No." . $item[1] . " のデータを読み込みました。下記データを修正して「処理」ボタンを押下して下さい。";
				$op  = "upd";
			}
			else	{
				$msg = "No." . $item[1] . " のデータは削除された可能性があります。読み込めませんでした。";
				$op  = "err";
			}
		}
	}
}
$check_ment	= "checked";
if ($op eq "")	{
	# 処理
	if ($mode eq "add")	{
		# 必須チェック
		if ($EudcText eq "" || $AddrText eq "" || $TelText eq "")	{
			$msg = "氏名、住所、電話は必須項目になります。データを入力して処理して下さい。";
			$op  = "err";
		}
		else	{
			if ($NoText eq "")	{
				# 新規
				if (&doUpdate("add",0))	{
					$msg = "No." . $NoText . " のデータを追加しました。";
					# 登録後はクリア（検索条件もクリア）
					$NoText_f	= $NoText	= "";
					$EudcText_f	= $EudcText	= "";
					$AddrText_f	= $AddrText	= "";
					$TelText_f	= $TelText	= "";
				}
				else	{
					$msg = "データの追加に失敗しました。（最大件[$addrMax]をオーバーした可能性があります）";
					$op  = "err";
				}
			}
			else	{
				# 更新
				if (&doUpdate("update",$NoText))	{
					$msg = "No." . $NoText . " のデータを更新しました。";
				}
				else	{
					$msg = "No." . $NoText . " のデータの更新に失敗しました。（削除された可能性があります）";
					$op  = "err";
				}
			}
		}
	}
	else {
		if ($mode eq "find")	{
			# 検索
			$NoText_f	= $NoText;
			$EudcText_f	= $EudcText;
			$AddrText_f	= $AddrText;
			$TelText_f	= $TelText;
			$check_find = "checked";
		}
		else	{
			# 項目消去
			$NoText_f	= $NoText	= "";
			$EudcText_f	= $EudcText	= "";
			$AddrText_f	= $AddrText	= "";
			$TelText_f	= $TelText	= "";
		}
	}
}

# ----------------------------------------------------------------------
# HTML固定部の編集処理

# HTLM編集（HEAD部）
$headHtml = << "HTML";
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>外字も利用できるアドレス帳</title>
<link rel=stylesheet type="text/css" href="style.css" title="style">
<script language="JavaScript">
// ポップアップウィンドウの表示
var wnd = new Array();
wnd.length = 0;
function popup(inUrl){
	closeAll();
	wnd[0] = open(inUrl, "", "width=500,height=600,menubar=no,resizable=yes,status=no,toolbar=no,scrollbars=yes");
}
function closeAll(){
	for (var i = 0; i < wnd.length; i++) wnd[i].close();
	wnd.length = 0;
}
</script>
</head>
HTML

# HTLM編集（BODY部）
$bodyHtml = << "HTML";
<body>
<div align="center">
<div id="container">
<div id="frm">

<div class="content_top">
<table cellspacing="6"><tr><td>
<table><tr><td width="590">
<strong>外字も利用できるアドレス帳&nbsp;&nbsp;［サンプルプログラム／APPLETタグ版］</strong>
</td><td><b>［&nbsp;<a href="$homePath">戻る</a>&nbsp;］</b></td></tr>
<tr><td><b>$msg</b></td><td>&nbsp;</td></tr></table>
<table><tr><td><form name="FormEudcInput" method="post" action="$cgiName">
<table class="topForm" border="0" cellspacing="10" cellpadding="0">
<tr>
	<td>No：
	</td>
	<td>
		<input type="text" name="NoText" value="$NoText" size="4" maxlength="6">
	</td>
	<td>&nbsp;
	</td>
	<td class="FomrInfo">※ <a href="javascript:popup('$helpUrl');">使い方の説明はこちらを見て下さい</a>。
	</td>
</tr>
<tr>
	<td width="38">氏名：
	</td>
	<td><!-- 外字入力アプレット -->
		<APPLET CODE="eudcInputText.class" ARCHIVE="../jclasses/eudcApl_v102.jar" WIDTH=244 HEIGHT=48 MAYSCRIPT>
		<PARAM NAME = ANS value="form=FormEudcInput,field=EudcText">
		<PARAM NAME = STL value="size=18,column=10,bgcolor=FFFFDF">
		</APPLET>
		<input type="hidden" name="EudcText" value="$EudcText">
	</td>
	<td width="38">住所：<br>電話：
	</td>
	<td>
		<input type="text" name="AddrText" value="$AddrText" size="40" maxlength="40"><br>
		<input type="text" name="TelText" value="$TelText" size="20" maxlength="20">
	</td>
</tr>
<tr>
	<td>&nbsp;
	</td>
	<td>
		<input class="buttonCss" type="submit" name =".submit" value="処理">
		<input type="radio" name = "mode" value="add"  $check_ment>登録
		<input type="radio" name = "mode" value="find" $check_find>検索
		<input type="radio" name = "mode" value="clear">リセット
	</td>
	<td>&nbsp;
	</td>
	<td>&nbsp;
	</td>
</tr>
</table>
</form></td></tr></table></td></tr></table>
</div>	<!-- class="content_top" -->

<div class="content_eudc_info">
<table class="eudc_info"  cellspacing="4"><tr><td>
	<APPLET CODE="eudcCodeList.class" ARCHIVE="../jclasses/eudcApl_v102.jar" WIDTH = 64 HEIGHT = 30>
	<PARAM NAME = MODE VALUE="list">
	</APPLET></td>
	<td>
	<APPLET CODE = eudcCodeList.class ARCHIVE="../jclasses/eudcApl_v102.jar" WIDTH = 64 HEIGHT = 30>
	<PARAM NAME = MODE VALUE="yomi">
	</APPLET></td>
	<td>
	利用出来る外字は、左のボタンより調べることができます。</td>
</td></tr></table>
</div>	<!-- class="content_eudc_info" -->

HTML

# HTLM編集（BODY部の一覧表示テンプレート）
$listHtml_1 = << "HTML";
<div class="content_list">
<table cellspacing="6"><tr><td>
<table class="list" border="0" cellspacing="0" cellpadding="0">
<tr>
	<td class="list_title" width="30">No.</td>
	<td class="list_title" width="200">氏名</td>
	<td class="list_title" width="390">住所／電話</td>
	<td class="list_title" width="60">処理</td>
</tr>
HTML

$listHtml_2 = << "HTML";
</tr></table></td></tr></table>
</div>	<!-- class="content_list" -->
</div>	<!-- id="frm" -->
</div>	<!-- id="container" -->
<div class="copyright">Copyright 2006 Gaiji.JJworkshop by HIRO.<br>
E-mail:<a href="mailto:info\@jjworkshop.com">info\@jjworkshop.com</a></div>
</div>	<!-- align="center" -->
HTML

# HTLM編集（一覧表示アイテムのテンプレート）
$itemHtml = << "HTML";
<tr>
	<td class="list_item">%NoText%</td>
	<td class="list_item">
	<APPLET CODE="eudcStaticText.class" ARCHIVE="../jclasses/eudcApl_v102.jar" WIDTH=200 HEIGHT=30>
	<PARAM NAME = STL VALUE="size=18,align=top">
	<PARAM NAME = STR VALUE="%EudcText%">
	</APPLET></td>
	<td class="list_item">%AddrText%<br>%TelText%</td>
	<td class="list_item"><a href="$cgiName?upd:%NoText%">修</a>／<a href="$cgiName?del:%NoText%">削</a></td>
</tr>
HTML


# HTLM編集（TAIL部）
$tailHtml = << "HTML";
<!-- 設定用のアプレット -->
<APPLET CODE ="eudcSetting.class" ARCHIVE="../jclasses/eudcApl_v102.jar" WIDTH=0 HEIGHT=0 NAME="eudcSetting">
<PARAM NAME = URL VALUE="$aplCgiFullPath">
<PARAM NAME = PORT VALUE="80">
</APPLET>
</body>
</html>
HTML


# ----------------------------------------------------------------------
# メイン処理


# HTML 出力
print "Content-type: text/html\n\n";
print $headHtml;
print $bodyHtml;

print $listHtml_1;

# アドレスデータ読み込み
if (-e "$addr_file") {
	# ファイル有り
} else {
	# ファイル無しは作成
	open(FIN,"+>>$addr_file");
	close(FIN);
}
open FIN, "$addr_file" or die "$addr_file オープン失敗";
while (<FIN>){
	$listData = $itemHtml;
	@datas = split(/:/, $_);
	if (chackFind(@datas))	{
		$listData =~ s/%NoText%/$datas[0]/g;
		$listData =~ s/%EudcText%/$datas[1]/g;
		$listData =~ s/%AddrText%/$datas[2]/g;
		$listData =~ s/%TelText%/$datas[3]/g;
		print $listData;
	}
}
close(FIN);

print $listHtml_2;
print $tailHtml;

exit;



# ----------------------------------------------------------------------
# サブルーチン群

# 指定の検索条件のデータかチェック
sub chackFind	{
	my ($no, $eudc,$addr,$tel) = @_;
	my $result = 1;
	if ($NoText_f ne "")	{
		if ($NoText_f ne $no)			{$result = 0;}
	}
	if ($result && $EudcText_f ne "")	{
		if ($eudc !~ /$EudcText_f+/)	{$result = 0;}
	}
	if ($result && $AddrText_f ne "")	{
		if ($addr !~ /$AddrText_f+/)	{$result = 0;}
	}
	if ($result && $TelText_f ne "")	{
		if ($tel !~ /$TelText_f+/)		{$result = 0;}
	}
	return ($result);
}

# ファイル処理 （1で正常終了）
sub doUpdate	{
	my $mod		= $_[0];
	my $no		= $_[1];
	my @datas;
	my $result	= 0;
	
	if ($mod eq "add")	{
		# 最大数チェック
		open F, "$addr_file"  or die "$addr_file オープン失敗";
		my $cnt = 0;
		while (<F>){$cnt++;}
		close(F);
		if ($addrMax > $cnt)	{
			# 追加処理
			$NoText = &lock(1);
			$EudcText	=~ s/[\r\n\f:]//g;
			$AddrText	=~ s/[\r\n\f:]//g;
			$TelText	=~ s/[\r\n\f:]//g;
			open(F,">> $addr_file");
			print F "$NoText:$EudcText:$AddrText:$TelText\n";
			close(F);
			&unlock;
			$result = 1;
		}
	}
	if ($mod eq "read")	{
		# 読み込み処理
		open F, "$addr_file"  or die "$addr_file オープン失敗";
		while (<F>){
			@datas = split(/:/, $_);
			if ($no eq $datas[0])	{
				$NoText		= $datas[0];
				$EudcText	= $datas[1];
				$AddrText	= $datas[2];
				$TelText	= $datas[3];
				$result = 1;
				last;
			}
		}
		close(F);
	}
	if ($mod eq "delete")	{
		# 削除
		&lock(0);
		open F, "$addr_file"   or die "$addr_file オープン失敗";
		open WK, ">> $wk_file" or die "$addr_file オープン失敗";
		truncate(WK, 0); 
		seek(WK,0,0);
		while (<F>){
			@datas = split(/:/, $_);
			if ($no eq $datas[0])	{
				$NoText		= "";
				$EudcText	= $datas[1];
				$AddrText	= $datas[2];
				$TelText	= $datas[3];
				$result = 1;
			}
			else	{
				print WK $_;
			}
		}
		close(WK);
		close(F);
		unlink($addr_file);
		rename($wk_file, $addr_file); 
		&unlock;
	}
	if ($mod eq "update")	{
		# 修正
		&lock(0);
		open F, "$addr_file"   or die "$addr_file オープン失敗";
		open WK, ">> $wk_file" or die "$addr_file オープン失敗";
		truncate(WK, 0); 
		seek(WK,0,0);
		while (<F>){
			@datas = split(/:/, $_);
			if ($no eq $datas[0])	{
				print WK "$NoText:$EudcText:$AddrText:$TelText\n";
				$result = 1;
			}
			else	{
				print WK $_;
			}
		}
		close(WK);
		close(F);
		unlink($addr_file);
		rename($wk_file, $addr_file); 
		&unlock;
	}
	
	return ($result);
}

# データロック
sub lock{
	my $buff;
	my $cnt;
	if (-e "lock.dat") {
		# ファイル有り
	} else {
		# ファイル無しは作成
		open(LOCK,"+>>lock.dat");
		close(LOCK);
	}
	open(LOCK,"+<lock.dat");
	flock(LOCK,2);
	if ($_[0] == 1)	{
		$cnt = <LOCK>;
		truncate(LOCK, 0); 
		seek(LOCK,0,0);
		$cnt++;
		print LOCK "$cnt\n";
	}
	return $cnt;
}
# ロック解除
sub unlock{
	close(LOCK);
}
